Index: dists/msvc71/cine.vcproj
===================================================================
--- dists/msvc71/cine.vcproj	(revision 24680)
+++ dists/msvc71/cine.vcproj	(working copy)
@@ -116,12 +116,6 @@
 			RelativePath="..\..\engines\cine\anim.h">
 		</File>
 		<File
-			RelativePath="..\..\engines\cine\auto00.cpp">
-		</File>
-		<File
-			RelativePath="..\..\engines\cine\auto00.h">
-		</File>
-		<File
 			RelativePath="..\..\engines\cine\bg.cpp">
 		</File>
 		<File
@@ -140,12 +134,9 @@
 			RelativePath="..\..\engines\cine\cine.h">
 		</File>
 		<File
-			RelativePath="..\..\engines\cine\font.cpp">
+			RelativePath="..\..\engines\cine\detection.cpp">
 		</File>
 		<File
-			RelativePath="..\..\engines\cine\font.h">
-		</File>
-		<File
 			RelativePath="..\..\engines\cine\gfx.cpp">
 		</File>
 		<File
Index: dists/msvc71/scummvm.sln
===================================================================
--- dists/msvc71/scummvm.sln	(revision 24680)
+++ dists/msvc71/scummvm.sln	(working copy)
@@ -62,11 +62,17 @@
 	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
 EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "touche", "touche.vcproj", "{43C2D921-FEE3-40BE-B58A-A6CA34235731}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
 Global
 	GlobalSection(SolutionConfiguration) = preSolution
 		Debug = Debug
 		Release = Release
 	EndGlobalSection
+	GlobalSection(ProjectDependencies) = postSolution
+	EndGlobalSection
 	GlobalSection(ProjectConfiguration) = postSolution
 		{8434CB15-D08F-427D-9E6D-581AE5B28440}.Debug.ActiveCfg = Debug|Win32
 		{8434CB15-D08F-427D-9E6D-581AE5B28440}.Debug.Build.0 = Debug|Win32
@@ -120,6 +126,10 @@
 		{15DF71E6-ECA9-45ED-8049-1CD7C987CCFE}.Debug.Build.0 = Debug|Win32
 		{15DF71E6-ECA9-45ED-8049-1CD7C987CCFE}.Release.ActiveCfg = Release|Win32
 		{15DF71E6-ECA9-45ED-8049-1CD7C987CCFE}.Release.Build.0 = Release|Win32
+		{43C2D921-FEE3-40BE-B58A-A6CA34235731}.Debug.ActiveCfg = Debug|Win32
+		{43C2D921-FEE3-40BE-B58A-A6CA34235731}.Debug.Build.0 = Debug|Win32
+		{43C2D921-FEE3-40BE-B58A-A6CA34235731}.Release.ActiveCfg = Release|Win32
+		{43C2D921-FEE3-40BE-B58A-A6CA34235731}.Release.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(ExtensibilityGlobals) = postSolution
 	EndGlobalSection
Index: dists/msvc71/scumm.vcproj
===================================================================
--- dists/msvc71/scumm.vcproj	(revision 24680)
+++ dists/msvc71/scumm.vcproj	(working copy)
@@ -115,6 +115,9 @@
 			Name="smush"
 			Filter="">
 			<File
+				RelativePath="..\..\engines\scumm\smush\channel.cpp">
+			</File>
+			<File
 				RelativePath="..\..\engines\scumm\smush\channel.h">
 			</File>
 			<File
@@ -124,9 +127,6 @@
 				RelativePath="..\..\engines\scumm\smush\chunk.h">
 			</File>
 			<File
-				RelativePath="..\..\engines\scumm\smush\chunk_type.h">
-			</File>
-			<File
 				RelativePath="..\..\engines\scumm\smush\codec1.cpp">
 			</File>
 			<File
@@ -269,6 +269,12 @@
 				RelativePath="..\..\engines\scumm\he\animation_he.h">
 			</File>
 			<File
+				RelativePath="..\..\engines\scumm\he\cup_player_he.cpp">
+			</File>
+			<File
+				RelativePath="..\..\engines\scumm\he\cup_player_he.h">
+			</File>
+			<File
 				RelativePath="..\..\engines\scumm\he\floodfill_he.cpp">
 			</File>
 			<File
Index: dists/msvc71/touche.vcproj
===================================================================
--- dists/msvc71/touche.vcproj	(revision 0)
+++ dists/msvc71/touche.vcproj	(revision 0)
@@ -0,0 +1,151 @@
+<?xml version="1.0" encoding="windows-1250"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="touche"
+	ProjectGUID="{43C2D921-FEE3-40BE-B58A-A6CA34235731}"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="touche_Debug"
+			IntermediateDirectory="touche_Debug"
+			ConfigurationType="4"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalOptions="/wd4201 /wd4512 /wd4511 /wd4100 /wd4121 /wd4310 /wd4706 /wd4127 /wd4189 /wd4702"
+				Optimization="0"
+				AdditionalIncludeDirectories="../..;../../engines"
+				PreprocessorDefinitions="WIN32;_DEBUG;USE_ZLIB;USE_MAD;USE_VORBIS;USE_MPEG2"
+				MinimalRebuild="TRUE"
+				ExceptionHandling="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="1"
+				BufferSecurityCheck="TRUE"
+				EnableFunctionLevelLinking="TRUE"
+				ForceConformanceInForLoopScope="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="4"
+				SuppressStartupBanner="FALSE"
+				DebugInformationFormat="4"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="$(OutDir)/touche.lib"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="touche_Release"
+			IntermediateDirectory="touche_Release"
+			ConfigurationType="4"
+			CharacterSet="2"
+			WholeProgramOptimization="FALSE">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalOptions="/wd4201 /wd4512 /wd4511 /wd4100 /wd4121 /wd4310 /wd4706 /wd4127 /wd4189 /wd4702"
+				Optimization="2"
+				InlineFunctionExpansion="1"
+				OmitFramePointers="TRUE"
+				AdditionalIncludeDirectories="../..;../../engines"
+				PreprocessorDefinitions="WIN32;NDEBUG;USE_ZLIB;USE_MAD;USE_VORBIS;USE_MPEG2"
+				StringPooling="TRUE"
+				ExceptionHandling="TRUE"
+				RuntimeLibrary="0"
+				BufferSecurityCheck="FALSE"
+				EnableFunctionLevelLinking="FALSE"
+				ForceConformanceInForLoopScope="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="4"
+				DebugInformationFormat="0"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="$(OutDir)/touche.lib"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<File
+			RelativePath="..\..\engines\touche\graphics.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\graphics.h">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\midi.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\midi.h">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\opcodes.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\plugin.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\resource.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\saveload.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\staticres.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\touche.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\touche.h">
+		</File>
+		<File
+			RelativePath="..\..\engines\touche\ui.cpp">
+		</File>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
Index: dists/msvc71/scummvm.vcproj
===================================================================
--- dists/msvc71/scummvm.vcproj	(revision 24680)
+++ dists/msvc71/scummvm.vcproj	(working copy)
@@ -97,7 +97,7 @@
 				Name="VCCustomBuildTool"/>
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="winmm.lib sdl.lib zdll.lib libmad.lib vorbisfile_static.lib vorbis_static.lib ogg_static.lib libmpeg2.lib agi_release/agi.lib cine_release/cine.lib gob_release/gob.lib kyra_release/kyra.lib lure_release/lure.lib queen_release/queen.lib saga_release/saga.lib scumm_release/scumm.lib agos_release/agos.lib sky_release/sky.lib sword1_release/sword1.lib sword2_release/sword2.lib"
+				AdditionalDependencies="winmm.lib sdl.lib zdll.lib libmad.lib vorbisfile_static.lib vorbis_static.lib ogg_static.lib libmpeg2.lib agi_release/agi.lib cine_release/cine.lib gob_release/gob.lib kyra_release/kyra.lib lure_release/lure.lib queen_release/queen.lib saga_release/saga.lib scumm_release/scumm.lib agos_release/agos.lib sky_release/sky.lib sword1_release/sword1.lib sword2_release/sword2.lib touche_release/touche.lib"
 				OutputFile="$(OutDir)/scummvm.exe"
 				LinkIncremental="1"
 				SuppressStartupBanner="TRUE"
@@ -142,12 +142,6 @@
 				RelativePath="..\..\base\commandLine.h">
 			</File>
 			<File
-				RelativePath="..\..\base\engine.cpp">
-			</File>
-			<File
-				RelativePath="..\..\base\engine.h">
-			</File>
-			<File
 				RelativePath="..\..\base\game.h">
 			</File>
 			<File
@@ -176,6 +170,12 @@
 			Name="common"
 			Filter="">
 			<File
+				RelativePath="..\..\common\advancedDetector.cpp">
+			</File>
+			<File
+				RelativePath="..\..\common\advancedDetector.h">
+			</File>
+			<File
 				RelativePath="..\..\common\array.h">
 			</File>
 			<File
@@ -191,12 +191,6 @@
 				RelativePath="..\..\common\config-manager.h">
 			</File>
 			<File
-				RelativePath="..\..\common\debugger.cpp">
-			</File>
-			<File
-				RelativePath="..\..\common\debugger.h">
-			</File>
-			<File
 				RelativePath="..\..\common\endian.h">
 			</File>
 			<File
@@ -215,6 +209,9 @@
 				RelativePath="..\..\common\func.h">
 			</File>
 			<File
+				RelativePath="..\..\common\hash-str.h">
+			</File>
+			<File
 				RelativePath="..\..\common\hashmap.cpp">
 			</File>
 			<File
@@ -466,6 +463,22 @@
 					</File>
 				</Filter>
 			</Filter>
+			<Filter
+				Name="mods"
+				Filter="">
+				<File
+					RelativePath="..\..\sound\mods\module.cpp">
+				</File>
+				<File
+					RelativePath="..\..\sound\mods\module.h">
+				</File>
+				<File
+					RelativePath="..\..\sound\mods\protracker.cpp">
+				</File>
+				<File
+					RelativePath="..\..\sound\mods\protracker.h">
+				</File>
+			</Filter>
 		</Filter>
 		<Filter
 			Name="txt"
@@ -593,6 +606,12 @@
 				RelativePath="..\..\gui\credits.h">
 			</File>
 			<File
+				RelativePath="..\..\gui\debugger.cpp">
+			</File>
+			<File
+				RelativePath="..\..\gui\debugger.h">
+			</File>
+			<File
 				RelativePath="..\..\gui\dialog.cpp">
 			</File>
 			<File
@@ -683,10 +702,16 @@
 				RelativePath="..\..\gui\theme.h">
 			</File>
 			<File
+				RelativePath="..\..\gui\themebrowser.cpp">
+			</File>
+			<File
+				RelativePath="..\..\gui\themebrowser.h">
+			</File>
+			<File
 				RelativePath="..\..\gui\ThemeClassic.cpp">
 			</File>
 			<File
-				RelativePath="..\..\gui\ThemeNew.cpp">
+				RelativePath="..\..\gui\ThemeModern.cpp">
 			</File>
 			<File
 				RelativePath="..\..\gui\widget.cpp">
@@ -699,12 +724,6 @@
 			Name="graphics"
 			Filter="">
 			<File
-				RelativePath="..\..\graphics\animation.cpp">
-			</File>
-			<File
-				RelativePath="..\..\graphics\animation.h">
-			</File>
-			<File
 				RelativePath="..\..\graphics\colormasks.h">
 			</File>
 			<File
@@ -750,6 +769,12 @@
 				RelativePath="..\..\graphics\imageman.h">
 			</File>
 			<File
+				RelativePath="..\..\graphics\mpeg_player.cpp">
+			</File>
+			<File
+				RelativePath="..\..\graphics\mpeg_player.h">
+			</File>
+			<File
 				RelativePath="..\..\graphics\paletteman.cpp">
 			</File>
 			<File
@@ -874,6 +899,16 @@
 				</File>
 			</Filter>
 		</Filter>
+		<Filter
+			Name="engines"
+			Filter="">
+			<File
+				RelativePath="..\..\engines\engine.cpp">
+			</File>
+			<File
+				RelativePath="..\..\engines\engine.h">
+			</File>
+		</Filter>
 	</Files>
 	<Globals>
 	</Globals>
Index: dists/msvc71/agos.vcproj
===================================================================
--- dists/msvc71/agos.vcproj	(revision 24680)
+++ dists/msvc71/agos.vcproj	(working copy)
@@ -111,6 +111,12 @@
 	</References>
 	<Files>
 		<File
+			RelativePath="..\..\engines\agos\agos.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\agos.h">
+		</File>
+		<File
 			RelativePath="..\..\engines\agos\animation.cpp">
 		</File>
 		<File
@@ -120,6 +126,9 @@
 			RelativePath="..\..\engines\agos\charset.cpp">
 		</File>
 		<File
+			RelativePath="..\..\engines\agos\contain.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\agos\cursor.cpp">
 		</File>
 		<File
@@ -144,15 +153,24 @@
 			RelativePath="..\..\engines\agos\game.cpp">
 		</File>
 		<File
+			RelativePath="..\..\engines\agos\gfx.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\agos\icons.cpp">
 		</File>
 		<File
+			RelativePath="..\..\engines\agos\input.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\agos\intern.h">
 		</File>
 		<File
 			RelativePath="..\..\engines\agos\items.cpp">
 		</File>
 		<File
+			RelativePath="..\..\engines\agos\menus.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\agos\midi.cpp">
 		</File>
 		<File
@@ -168,15 +186,42 @@
 			RelativePath="..\..\engines\agos\res.cpp">
 		</File>
 		<File
+			RelativePath="..\..\engines\agos\res_ami.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\res_snd.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\rooms.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\agos\saveload.cpp">
 		</File>
 		<File
-			RelativePath="..\..\engines\agos\agos.cpp">
+			RelativePath="..\..\engines\agos\script.cpp">
 		</File>
 		<File
-			RelativePath="..\..\engines\agos\agos.h">
+			RelativePath="..\..\engines\agos\script_e1.cpp">
 		</File>
 		<File
+			RelativePath="..\..\engines\agos\script_e2.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\script_ff.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\script_pp.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\script_s1.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\script_s2.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\script_ww.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\agos\sound.cpp">
 		</File>
 		<File
@@ -198,8 +243,26 @@
 			RelativePath="..\..\engines\agos\vga.h">
 		</File>
 		<File
+			RelativePath="..\..\engines\agos\vga_e2.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\vga_ff.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\vga_s1.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\vga_s2.cpp">
+		</File>
+		<File
+			RelativePath="..\..\engines\agos\vga_ww.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\agos\window.cpp">
 		</File>
+		<File
+			RelativePath="..\..\engines\agos\zones.cpp">
+		</File>
 	</Files>
 	<Globals>
 	</Globals>
Index: dists/msvc71/agi.vcproj
===================================================================
--- dists/msvc71/agi.vcproj	(revision 24680)
+++ dists/msvc71/agi.vcproj	(working copy)
@@ -204,6 +204,9 @@
 			RelativePath="..\..\engines\agi\picture.h">
 		</File>
 		<File
+			RelativePath="..\..\engines\agi\predictive.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\agi\savegame.cpp">
 		</File>
 		<File
Index: dists/msvc71/kyra.vcproj
===================================================================
--- dists/msvc71/kyra.vcproj	(revision 24680)
+++ dists/msvc71/kyra.vcproj	(working copy)
@@ -185,6 +185,9 @@
 			RelativePath="..\..\engines\kyra\sequences_v1.cpp">
 		</File>
 		<File
+			RelativePath="..\..\engines\kyra\sequences_v2.cpp">
+		</File>
+		<File
 			RelativePath="..\..\engines\kyra\sound.cpp">
 		</File>
 		<File
Index: dists/msvc71/saga.vcproj
===================================================================
--- dists/msvc71/saga.vcproj	(revision 24680)
+++ dists/msvc71/saga.vcproj	(working copy)
@@ -227,6 +227,12 @@
 			RelativePath="..\..\engines\saga\saga.h">
 		</File>
 		<File
+			RelativePath="..\..\engines\saga\sagagame.h">
+		</File>
+		<File
+			RelativePath="..\..\engines\saga\sagaresnames.h">
+		</File>
+		<File
 			RelativePath="..\..\engines\saga\saveload.cpp">
 		</File>
 		<File